(* #use "debugcode/debug.ml";; *)

generic plus = 
| int -> int -> int => (+)
| float -> float -> float => (+.)
;;
plus 21 21;;
plus 21.0 21.0;;

let double x = plus x x;;
double 21;;
double 21.0;;

let double x = 
  generic plus = 
  | int -> int -> int => (+)
  | float -> float -> float => (+.)
  in
  plus x x;;
double 21;;
double 21.0;;

generic rec print = 
| int -> unit => print_int
| float -> unit => print_float
| $a list -> unit => fun l -> List.iter print l
;;
print 42;;
print (double 21.0);;
print [42.0];; 

let quat x =
  let double x =
    generic plus =
    | int -> int -> int => (+)
    | float -> float -> float => (+.)
    in
    plus x x
  in
  double (double x)
;;
quat 10.5;;

let double x =
  generic plus = 
  | int -> int -> int => (+)
  | float -> float -> float => (+.)
  in
  generic minus = 
  | int -> int -> int => (-)
  | float -> float -> float => (-.)
  in
  minus (plus (plus x x) (plus x x)) (plus x x);;
double 21.0;;
  
(* philippe.esperet *)

let add_vect v1 v2=
  let v=Array.create (Array.length v1) v1.(0) in
  for i=0 to (Array.length v1)-1 do
    v.(i)<- plus v1.(i) v2.(i) done;
  v
;;

add_vect [|21;10|]  [|21;32|] ;;
add_vect [|21.0;10.0|]  [|21.0;32.0|] ;;

(* patrick *)

generic head =
| $a list -> $a => List.hd
;;
generic incr =
| $a list -> $a list => List.tl
;;
let rec for_each f first last =
  if first = last then ()
  else begin
    f (head first);
    for_each f (incr first) last
  end
;;
for_each Toploop.print [42;4242;424242] []
;;

(* flat *)

generic rec flat = 
| $a list list -> $b list => fun l -> flat (List.flatten l)
| $a list -> $a list => fun l -> l
;;
flat [[[42]]];;

(* dyn *)
coerce (dyn (fun x -> x)) with
| (f : 'a -> 'a) => 
    f (coerce (dyn 42) with
       | (x : int) => flat (f [[[f x]]]))
;;

(* _ *)

let _ = fun x -> plus x x;;

(* mut recs *)
generic rec print1 =
| int -> unit => print_int
| float -> unit => print_float
| $a -> unit => prints
and prints =
| $a list -> unit => fun l -> List.iter prints l
| $a -> unit => print1
;;

let _ = print1 [[[4.0];[2.0]]];;

(* mut recs *)
generic rec prints =
| $a array -> unit => fun l -> Array.iter prints l
| include prints
;;

let _ = prints [| [ [| 4.0 |] ]; [ [| 2.0 |] ] |];;
