open Rdigest

(*
exception Type_match_failure of (rpath * type_info) rtype * (rpath * type_info) rtype * string * int * int
*)
exception Type_match_failure of (rpath * type_info) rtype * string * int * int

val type_of : dyn -> (rpath * type_info) rtype

val is_instance : 'a rtype -> 'a rtype -> bool

val dynamic_comp : 
    (rpath * type_info) rtype -> 'a -> ('a * (rpath * type_info) rtype)
val fail : (rpath * type_info) rtype -> string -> int -> int -> 'a
val coerce_comp : 
    (string * int * int) -> (rpath * type_info) rtype -> 
      ('a * (rpath * type_info) rtype) -> 'a 

(*** Generic primitives *)
(* They cannot be declared as usual values in .mli *)

external dyn : $a -> dyn = "%dynamic" "generic" "dynamic"
external crc : dyn -> $a = "%coerce" "generic" "coerce"

external export_value : out_channel -> $a -> unit = "%export_value" "generic" "dynamic"
external import_value : in_channel -> $a = "%import_value" "generic" "coerce"

external export_to_string : $a -> string = "%export_to_string" "generic" "dynamic"
external import_from_string : string -> $a = "%import_from_string" "generic" "coerce"
