(* generic bindings *)

(* The simplest example *)
generic plus = case 
| int -> int -> int => (+)
| float -> float -> float => (+.)
;;
 
(* You can write the approximation scheme (usually it is guessed) *)
generic (plus : $a -> $a -> $a) = case 
| int -> int -> int => (+)
| float -> float -> float => (+.)
;;
 
(* You may even write a bigger approx. *)
generic (plus : $a) = case 
| int -> int -> int => (+)
| float -> float -> float => (+.)
;;
 
(* Approximations must be greater than the any patterns *)
(* ERROR
generic (plus : $a -> $a) = case 
| int -> int -> int => (+)
| float -> float -> float => (+.)
;;
*)

(* Generic ... in *)
generic plus = case
| int -> int -> int => (+)
| float -> float -> float => (+.)
in
plus 1 2
;;

(* generic pattern must be an identifier *)
(* ERROR
generic x,y = case
| int * int => 1, 1
| float * float => 1.0, 1.0
;;
