(* Lev. 1 *)
generic rec print = case $a -> unit of 
  << int ->     unit >> -> print_int
| << float ->   unit >> -> print_float
| << string ->  unit >> -> print_string
| << char ->    unit >> -> print_char
| << $a list -> unit >> -> (fun l -> List.iter print l) 
;;

(* Lev. 2 - nice list printing 
(with use of a recursive derived polymorphic inside) 
*)
generic rec print = case $a -> unit of 
  << int ->     unit >> -> print_int
| << float ->   unit >> -> print_float
| << string ->  unit >> -> 
    (fun x -> print_string "\""; print_string x; print_string "\"")
| << char ->    unit >> -> 
    (fun x -> print_string "\'"; print_char x; print_string "\'")
| << $a list -> unit >> -> 
    (fun lst -> 
      print_string "[";
      let rec printer = function
	  [] -> print_string "]"
	| [x] -> print x; print_string "]"
	| x :: xs -> print x; print_string "; "; printer xs
      in
      printer lst)
;;

let print_twice x = print x; print x
;;
(* It has two print : $a -> unit in konstraints *)

let rec print_ntimes x = function
  | 0 -> ()
  | n -> print x; print_ntimes x (n-1)
;;
